#include "../std.h"

#include "../misc/stringtoint.h"
#include "../misc/inttostring.h"
#include "time_utils.h"


int stringtotime(struct tm &t,const string &s) {
  if(s.length() != 14) {
    return -1;
  };
  if((!stringtoint(s.substr(0,4),t.tm_year)) ||
     (!stringtoint(s.substr(4,2),t.tm_mon)) ||
     (!stringtoint(s.substr(6,2),t.tm_mday)) ||
     (!stringtoint(s.substr(8,2),t.tm_hour)) ||
     (!stringtoint(s.substr(10,2),t.tm_min)) ||
     (!stringtoint(s.substr(12,2),t.tm_sec))) {
    return -1;
  };
  t.tm_year-=1900;
  return 0;
}

int timetostring(const struct tm &t,string &s) {
  char buf[256];
  int l = snprintf(buf,255,"%04u%02u%02u%02u%02u%02u",
    t.tm_year+1900,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec);
  buf[l]=0; s=buf;
  return (l==14)?0:1;
}


